'SysAlive main form: frmSysAlive
'by Luke Huckaba (cougar694u) - luke@69cougar.com
'05/11/06
'
'I'm not a CS major, just took VB.NET 2003 in the spring 2006 semester and decided
'try it out for a tool that pings hosts to see if they're alive.
'I used VB.NET 2005 to create the program. It's really simple,
'I'm sure anyone can follow it.
'
'If you see stupid things that need to be changed, let me know,
'this is my first program.
'
'~Luke

'We have to import these namespaces or some things won't work,
'like sending the e-mail, accessing the XML file, etc
Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports System.Net.Mail
Imports System.Text

Public Class frmSysAlive

    Inherits System.Windows.Forms.Form

    'we need some variables and they need to be public shared
    'in order for them to be changed in other forms
    Public Shared timeIntervalInteger As Integer
    Public Shared pingTimeOutInteger As Integer
    Public Shared smtpServerAddress As String
    Public Shared fromAddress As String
    Public Shared toAddress As String
    Public Shared ccAddress As String
    Public Shared bccAddress As String

    'this tells us where our files are, relative to the program
    Public ReadOnly settingsFile As String = "settings.xml"
    Public ReadOnly hostsFile As String = "hosts.txt"

    'set the array for the ping count, we'll redim when
    'populating the list box
    Private deadPingCountInteger(-1) As Integer

    'variables for the IO stuff
    Dim writeSettings As IO.StreamWriter
    Dim readSettings As IO.StreamReader

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents exitButton As System.Windows.Forms.Button
    Friend WithEvents Timer As System.Windows.Forms.Timer
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents ipListBox As System.Windows.Forms.ListBox
    Friend WithEvents ContextMenuStrip1 As System.Windows.Forms.ContextMenuStrip
    Friend WithEvents addRemoveHostToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents MenuStrip1 As System.Windows.Forms.MenuStrip
    Friend WithEvents fileMenu As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents fileAddHostMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolStripMenuItem1 As System.Windows.Forms.ToolStripSeparator
    Friend WithEvents fileExitMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents AboutToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents AboutToolStripMenuItem1 As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents OptionsToolStripMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents enableCheckBox As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.exitButton = New System.Windows.Forms.Button
        Me.Timer = New System.Windows.Forms.Timer(Me.components)
        Me.enableCheckBox = New System.Windows.Forms.CheckBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.ipListBox = New System.Windows.Forms.ListBox
        Me.ContextMenuStrip1 = New System.Windows.Forms.ContextMenuStrip(Me.components)
        Me.addRemoveHostToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.MenuStrip1 = New System.Windows.Forms.MenuStrip
        Me.fileMenu = New System.Windows.Forms.ToolStripMenuItem
        Me.fileAddHostMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.OptionsToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.ToolStripMenuItem1 = New System.Windows.Forms.ToolStripSeparator
        Me.fileExitMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.AboutToolStripMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.AboutToolStripMenuItem1 = New System.Windows.Forms.ToolStripMenuItem
        Me.ContextMenuStrip1.SuspendLayout()
        Me.MenuStrip1.SuspendLayout()
        Me.SuspendLayout()
        '
        'exitButton
        '
        Me.exitButton.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.exitButton.Location = New System.Drawing.Point(50, 230)
        Me.exitButton.Name = "exitButton"
        Me.exitButton.Size = New System.Drawing.Size(75, 23)
        Me.exitButton.TabIndex = 4
        Me.exitButton.Text = "E&xit"
        '
        'Timer
        '
        Me.Timer.Interval = 100000
        '
        'enableCheckBox
        '
        Me.enableCheckBox.AutoSize = True
        Me.enableCheckBox.Location = New System.Drawing.Point(60, 207)
        Me.enableCheckBox.Name = "enableCheckBox"
        Me.enableCheckBox.Size = New System.Drawing.Size(65, 17)
        Me.enableCheckBox.TabIndex = 3
        Me.enableCheckBox.Text = "Enabled"
        Me.enableCheckBox.UseVisualStyleBackColor = True
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(57, 32)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(37, 13)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Hosts:"
        '
        'ipListBox
        '
        Me.ipListBox.ContextMenuStrip = Me.ContextMenuStrip1
        Me.ipListBox.FormattingEnabled = True
        Me.ipListBox.Location = New System.Drawing.Point(12, 53)
        Me.ipListBox.Name = "ipListBox"
        Me.ipListBox.Size = New System.Drawing.Size(162, 147)
        Me.ipListBox.TabIndex = 2
        '
        'ContextMenuStrip1
        '
        Me.ContextMenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.addRemoveHostToolStripMenuItem})
        Me.ContextMenuStrip1.Name = "ContextMenuStrip1"
        Me.ContextMenuStrip1.Size = New System.Drawing.Size(205, 26)
        '
        'addRemoveHostToolStripMenuItem
        '
        Me.addRemoveHostToolStripMenuItem.Name = "addRemoveHostToolStripMenuItem"
        Me.addRemoveHostToolStripMenuItem.Size = New System.Drawing.Size(204, 22)
        Me.addRemoveHostToolStripMenuItem.Text = "&Add and Remove Host..."
        '
        'MenuStrip1
        '
        Me.MenuStrip1.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.fileMenu, Me.AboutToolStripMenuItem})
        Me.MenuStrip1.Location = New System.Drawing.Point(0, 0)
        Me.MenuStrip1.Name = "MenuStrip1"
        Me.MenuStrip1.Size = New System.Drawing.Size(186, 24)
        Me.MenuStrip1.TabIndex = 0
        Me.MenuStrip1.Text = "MenuStrip1"
        '
        'fileMenu
        '
        Me.fileMenu.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.fileAddHostMenuItem, Me.OptionsToolStripMenuItem, Me.ToolStripMenuItem1, Me.fileExitMenuItem})
        Me.fileMenu.Name = "fileMenu"
        Me.fileMenu.Size = New System.Drawing.Size(35, 20)
        Me.fileMenu.Text = "&File"
        '
        'fileAddHostMenuItem
        '
        Me.fileAddHostMenuItem.Name = "fileAddHostMenuItem"
        Me.fileAddHostMenuItem.Size = New System.Drawing.Size(204, 22)
        Me.fileAddHostMenuItem.Text = "&Add and Remove Host..."
        '
        'OptionsToolStripMenuItem
        '
        Me.OptionsToolStripMenuItem.Name = "OptionsToolStripMenuItem"
        Me.OptionsToolStripMenuItem.Size = New System.Drawing.Size(204, 22)
        Me.OptionsToolStripMenuItem.Text = "Options..."
        '
        'ToolStripMenuItem1
        '
        Me.ToolStripMenuItem1.Name = "ToolStripMenuItem1"
        Me.ToolStripMenuItem1.Size = New System.Drawing.Size(201, 6)
        '
        'fileExitMenuItem
        '
        Me.fileExitMenuItem.Name = "fileExitMenuItem"
        Me.fileExitMenuItem.Size = New System.Drawing.Size(204, 22)
        Me.fileExitMenuItem.Text = "E&xit"
        '
        'AboutToolStripMenuItem
        '
        Me.AboutToolStripMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.AboutToolStripMenuItem1})
        Me.AboutToolStripMenuItem.Name = "AboutToolStripMenuItem"
        Me.AboutToolStripMenuItem.Size = New System.Drawing.Size(40, 20)
        Me.AboutToolStripMenuItem.Text = "&Help"
        '
        'AboutToolStripMenuItem1
        '
        Me.AboutToolStripMenuItem1.Name = "AboutToolStripMenuItem1"
        Me.AboutToolStripMenuItem1.Size = New System.Drawing.Size(114, 22)
        Me.AboutToolStripMenuItem1.Text = "&About"
        '
        'frmSysAlive
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(186, 264)
        Me.Controls.Add(Me.MenuStrip1)
        Me.Controls.Add(Me.ipListBox)
        Me.Controls.Add(Me.enableCheckBox)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.exitButton)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.MainMenuStrip = Me.MenuStrip1
        Me.MaximizeBox = False
        Me.Name = "frmSysAlive"
        Me.Text = "SysAlive v0.4"
        Me.ContextMenuStrip1.ResumeLayout(False)
        Me.MenuStrip1.ResumeLayout(False)
        Me.MenuStrip1.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick

        'At every tick of the timer (depending on what you set the timer to)
        'it executes this code
        Dim hostString As String
        Dim pingResults As String
        Dim i As Integer = 0
        Dim SendBadEmail As New classDeadEmail
        Dim sendGoodEmail As New classAliveEmail
        Dim totHostsInteger As Integer = ipListBox.Items.Count - 1

        'this is here so that it checks it's timer setting everytime it runs
        'and will change on the fly without having to disable & enable
        Timer.Interval = timeIntervalInteger

        'for every item in the listbox, do the following
        'it also picks up changes on the fly

        For i = 0 To totHostsInteger
            hostString = ipListBox.Items(i)

            Try
                'ping the host and set the results variabl
                pingResults = My.Computer.Network.Ping(hostString, pingTimeOutInteger)

                'if it worked
                If pingResults = True Then

                    'if it was a previously dead host, alert the user it's back online
                    'and reset the dead variable back to 0
                    If deadPingCountInteger(i) > 9 Then
                        If Format(Now, "HHmmss") >= "223000" Or Format(Now, "HHmmss") <= "053000" Then
                            deadPingCountInteger(i) = 0
                        Else
                            sendGoodEmail = New classAliveEmail(hostString)
                            deadPingCountInteger(i) = 0
                        End If
                    Else

                        'previously alive host keeps its dead count at 0
                        deadPingCountInteger(i) = 0
                    End If
                Else

                    'if it didn't
                    deadPingCountInteger(i) += 1
                End If

                'I'll probably add the amount of dead pings before an e-mail is sent
                'to the settings form, but 10 is okay to me, just adjust the interval
                If deadPingCountInteger(i) = 10 Then
                    'Call SendBadEmail(hostString)

                    If Format(Now, "HHmmss") >= "223000" Or Format(Now, "HHmmss") <= "053000" Then
                        Exit Sub
                    Else
                        SendBadEmail = New classDeadEmail(hostString)
                    End If
                End If

            Catch ex As Exception
                'this is in case any errors arise above from the ping.
                'after running the program several hours, it would crash randomly from a ping error
                'it should go on to the next in line, I hope.  Again, I'm a noob.
                Exit Try

            End Try
        Next

    End Sub

    Private Sub enableCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles enableCheckBox.CheckedChanged

        'update the timer interval
        Timer.Interval = timeIntervalInteger

        If enableCheckBox.Checked = True Then

            'if there's nothing in the list box, let the user know they need something there
            If ipListBox.Items.Count = 0 Then
                enableCheckBox.Checked = False
                Timer.Enabled = False
                MessageBox.Show("Sorry, you must go to File | Add Host to add hosts to be monitored", _
                "No hosts to monitor", MessageBoxButtons.OK, MessageBoxIcon.Hand)
                Exit Sub
            End If
            Timer.Enabled = True
        Else
            Timer.Enabled = False
        End If

    End Sub

    Private Sub exitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitButton.Click, fileExitMenuItem.Click

        Me.Close()
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem1.Click
        Dim aboutForm As New frmAbout

        'dimension the frmAbout form and display it with showdialog
        'so you can't click on anything else until you close it
        aboutForm.ShowDialog()

    End Sub

    Private Sub OptionsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OptionsToolStripMenuItem.Click
        Dim optionsForm As New frmOptions

        'shows the options form
        optionsForm.ShowDialog()

    End Sub


    Private Sub frmSysAlive_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'see below
        UpdateSettings()
        OpenHostsFile()
    End Sub

    Public Sub UpdateSettings()
        'This sub pulls the settings from the XML file

        Dim cf As New classConfig
        Dim ser As New XmlSerializer(cf.GetType)
        Dim fs As FileStream
        Dim tw As TextWriter

        'If the file exists, then populate the variables
        If (File.Exists(settingsFile)) Then

            fs = New FileStream(settingsFile, FileMode.Open)
            cf = CType(ser.Deserialize(fs), classConfig)
            pingTimeOutInteger = cf.Ping
            timeIntervalInteger = cf.Tick
            smtpServerAddress = cf.SMTP
            fromAddress = cf.From
            toAddress = cf.ToAddress
            ccAddress = cf.CC
            bccAddress = cf.BCC
            fs.Close()

        Else

            'if it doesn't exist, use these defaults and it'll be created
            'when the user goes into the options menu and saves.
            fs = New FileStream(settingsFile, FileMode.CreateNew)
            pingTimeOutInteger = 300
            timeIntervalInteger = 30000
            smtpServerAddress = "localhost"
            fromAddress = "admin@localhost"
            toAddress = "admin@localhost"
            ccAddress = ""
            bccAddress = ""

            tw = New StreamWriter(fs)
            ser.Serialize(tw, cf)
            tw.Close()
            fs.Close()

        End If
    End Sub

    Private Sub fileAddHostMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles fileAddHostMenuItem.Click, addRemoveHostToolStripMenuItem.Click

        Dim form As New frmAddRemoveHost
        form.ShowDialog()

    End Sub

    Public Sub SaveHostsFile()
        'this sub saves the hosts in the list box to a simple text file

        Dim i As Integer
        writeSettings = New IO.StreamWriter(hostsFile)
        For i = 0 To ipListBox.Items.Count - 1
            writeSettings.WriteLine(ipListBox.Items.Item(i))
        Next
        writeSettings.Close()

    End Sub

    Public Sub OpenHostsFile()
        'this sub opens the hosts text file

        'if it doesn't exist, it automatically enters the localhost IP address
        If Not File.Exists(hostsFile) Then
            ipListBox.Items.Add("127.0.0.1")
        Else
            readSettings = New IO.StreamReader(hostsFile)
            While (readSettings.Peek() > -1)
                ipListBox.Items.Add(readSettings.ReadLine)
            End While
            readSettings.Close()
        End If

        'ReDim the array to match the number of hosts in the list box
        ReDim deadPingCountInteger(ipListBox.Items.Count - 1)

    End Sub

End Class

